-------------------------------------------------------
-- 8bit buffer
-- 2021/10/13
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity buff8bit is
	port(
		outz	:in std_logic;
		d0		:in std_logic;
		d1		:in std_logic;
		d2		:in std_logic;
		d3		:in std_logic;
		d4		:in std_logic;
		d5		:in std_logic;
		d6		:in std_logic;
		d7		:in std_logic;		
		q0		:out std_logic;
		q1		:out std_logic;
		q2		:out std_logic;
		q3		:out std_logic;
		q4		:out std_logic;
		q5		:out std_logic;
		q6		:out std_logic;
		q7		:out std_logic		
	);
end buff8bit;

architecture rtl of buff8bit is
	signal input_data	:std_logic_vector(7 downto 0);
	signal out_data	:std_logic_vector(7 downto 0);
	signal out_z :std_logic;

begin

	out_z <= outz;
	input_data <= d7 & d6 & d5 & d4 & d3 & d2 & d1 & d0;

	out_data <= input_data when out_z='0' else "ZZZZZZZZ";
	
	q0 <= out_data(0);
	q1 <= out_data(1);
	q2 <= out_data(2);
	q3 <= out_data(3);
	q4 <= out_data(4);
	q5 <= out_data(5);
	q6 <= out_data(6);
	q7 <= out_data(7);	

end rtl;