-------------------------------------------------------
-- h_sync v_sync system next2 addr 640 480 set wsel
-- 20022/4/23
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity hsyncvsyncsysnext2addr640480setwsel is
	port(
		clk	:in std_logic;
		clear	:in std_logic;
		chelatch:in std_logic;
		inset	:in std_logic;
		wsel	:in std_logic;
		hsync	:out std_logic;
		vsync	:out std_logic;
		out1	:out std_logic;
		out2	:out std_logic;
		out3  :out std_logic;
		out4  :out std_logic;
		out5	:out std_logic;
		out6	:out std_logic;
		out2s	:out std_logic;
		out7	:out std_logic;
		ad0	:out std_logic;
		ad1	:out std_logic;
		ad2	:out std_logic;
		ad3	:out std_logic;
		ad4	:out std_logic;
		ad5	:out std_logic;
		ad6	:out std_logic;
		ad7	:out std_logic;
		ad8	:out std_logic;
		ad9	:out std_logic;
		ad10	:out std_logic;
		ad11	:out std_logic;
		ad12	:out std_logic;
		ad13	:out std_logic;
		ad14	:out std_logic;
		ad15	:out std_logic;
		ad16	:out std_logic;
		ad17	:out std_logic;
		outmask:out std_logic;
		outset:out std_logic
	);
end hsyncvsyncsysnext2addr640480setwsel;

architecture rtl of hsyncvsyncsysnext2addr640480setwsel is
	signal hcounter	:std_logic_vector(11 downto 0);
	signal vcounter	:std_logic_vector(9 downto 0);
	signal h_sync		:std_logic;
	signal v_sync		:std_logic;
	signal video_en	:std_logic;
	signal h_en			:std_logic;
	signal v_en			:std_logic;
	signal h_flg		:std_logic;
	signal out_1		:std_logic;
	signal out_2		:std_logic;
	signal out_3   	:std_logic;
	signal out_4		:std_logic;
	signal out_5		:std_logic;
	signal dcount		:std_logic_vector(2 downto 0);
	signal latch_flg	:std_logic;
	signal sub_1		:std_logic;
	signal sub_2		:std_logic;
	signal out_2s		:std_logic;
	signal sub_3		:std_logic;
	signal out_7		:std_logic;
	signal incounter	:std_logic_vector(17 downto 0);
	signal out_2su		:std_logic;
	signal mask			:std_logic;
	signal o_set		:std_logic;
	
begin
	video_en <= h_en and v_en;
	process(clk,clear)
	begin
		if(clear ='1') then
			--hcounter <="000000000000";
			--vcounter <="0000000000";
			--dcount <="000";
			--out_1 <= '0';
			--out_2 <= '1';
			--out_3 <= '0';
			--out_4 <= '1';
			--out_5 <= '0';
			--latch_flg <= '0';
			--h_flg <= '0';
			--sub_1 <='0';
			--sub_2 <='0';
			--out_2s <='0';
			--sub_3 <='0';
			--out_7 <='0';
			--incounter <= "000000000000000001";
			--out_2su <='0';
			--mask <='1';
			--o_set <= '0';
			elsif(clk' event and clk='1') then
			
				dcount <= dcount+1;	
				
				if (dcount = "001")then
					out_1 <='1';
					out_2 <='1';
					out_2s <='0';
					out_3 <='0';
					sub_1 <='1';
					out_2su <='0';
				end if;
				if (dcount = "010")then
					out_1 <='1';
					out_2 <='0';
					out_2s <='0';
					out_3 <='0';
					sub_1 <='1';
					out_2su <='0';
				end if;
				if (dcount = "011")then
					out_1 <='1';
					out_2 <='0';
					out_2s <='1';
					out_3 <='1';
					sub_1 <='1';
					out_2su <='0';
				end if;
				if (dcount = "100")then
					out_1 <='0';
					out_2 <='1';
					out_2s <='1';
					out_3 <='1';
					sub_1 <='0';
					out_2su <='0';
				end if;	
				if (dcount = "101")then
					out_1 <='0';
					out_2 <='1';
					out_2s <='0';
					out_3 <='1';
					sub_1 <='0';
					out_2su <='0';
				end if;	
				if (dcount = "110")then
					out_1 <='0';
					out_2 <='1';
					out_2s <='0';
					out_3 <='1';
					sub_1 <='0';
					out_2su <='1';
				end if;	
				if (dcount = "111")then
					out_1 <='0';
					out_2 <='1';
					out_2s <='0';
					out_3 <='0';
					sub_1 <='1';
					out_2su <='0';
				end if;	
				if (dcount = "000")then
					out_1 <='0';
					out_2 <='1';
					out_2s <='0';
					out_3 <='0';
					sub_1 <='1';
					out_2su <='0';
				end if;					
				
				if (out_4='0') then
					if (sub_3='1') then
						out_4 <='1';
						out_5 <='1';
						out_7 <='1';
					end if;
				end if;

				if (latch_flg ='1') and (sub_2='1') then
					sub_3 <='1';
				end if;
				
				if (latch_flg ='1') and (sub_1 ='0') and (sub_2='0') then
					out_4 <='0';
					sub_2 <='1';
				end if;

				if (chelatch ='1') then
					latch_flg <='1';
				else
					latch_flg <='0';
					out_4 <='1';
					out_5 <='0';
					sub_2 <='0';
					sub_3 <='0';
					out_7 <='0';
				end if;

				
				if (hcounter = 799*4) then
					hcounter <="000000000000";
					dcount <="101";---100
				else
					hcounter <=hcounter+1;
				end if;


				if (hcounter <=751*4) and (hcounter >=655*4) then
					h_sync <='0';
				else
					h_sync <='1';
				end if;
				
				if (vcounter >= 524) and (hcounter >=799*4) then  ---799
					vcounter <="0000000000";
					dcount <= "101";---100
					incounter <= "000000000000000001";
					mask <='1';
				else if (hcounter = 639*4) then---639
					vcounter <=vcounter+1;

				end if;

				if (wsel = '1') then
				----------------------------------------------------------
					if (vcounter <=118) then						--- TEST
						incounter <= "000000000000000001";		--- TEST
					end if;												--- TEST
			
					if (vcounter<=118) or (vcounter >=(241+118)) then --- TEST 239
						mask <='0';
					else
						mask <='1';
					end if;
				-----------------------------------------------------------
				end if;
				
				if (vcounter <= 491) AND (vcounter >= 489) then
					v_sync <= '0';	
				else
					v_sync <= '1';
				end if;

				if (hcounter < 639*4) then  ---639 <=
					h_en <= '1';
				else
					h_en <= '0';
				end if;
	
				if (vcounter < 479) then	--- <=
					v_en <= '1';
				else
					v_en <= '0';
				end if;
				
				if (h_en ='0') or (v_en='0') then
					out_2 <='1';
					out_2s <='0';
					out_2su <='0';
				end if;
				
				if (video_en ='0') then
					out_1 <='0';
				end if;


				if (inset = '1') and (wsel ='0') then
					if (vcounter >= 446) and (vcounter <= 479) then
						o_set <= '1';
					else 
						o_set <= '0';
					end if;
				else
					o_set <= '0';
				end if;
				
				if (inset = '1') and (wsel ='1') then
					if (vcounter >= 325) and (vcounter <= 359) then
						o_set <= '1';
					else 
						o_set <= '0';
					end if;
				else
					o_set <= '0';
				end if;			
				
				if (vcounter < 479) AND (hcounter < 639*4) AND (out_2su='1')then  --- TEST 479  <=
				incounter <= incounter+1;
				end if;		
				
				
			end if;
		end if;
		hsync <= h_sync;
		vsync <= v_sync;
		out1 <= out_1;
		out2 <= out_2;
		out3 <= out_3;
		out4 <= out_4;
		out5 <= out_5;
		out6 <= h_en and v_en;	--video_en;
		out2s <= out_2s;
		out7 <= out_7;

		ad0 <= incounter(0);
		ad1 <= incounter(1);
		ad2 <= incounter(2);
		ad3 <= incounter(3);
		ad4 <= incounter(4);
		ad5 <= incounter(5);
		ad6 <= incounter(6);
		ad7 <= incounter(7);
		ad8 <= incounter(8);
		ad9 <= incounter(9);
		ad10 <= incounter(10);
		ad11 <= incounter(11);
		ad12 <= incounter(12);
		ad13 <= incounter(13);
		ad14 <= incounter(14);
		ad15 <= incounter(15);
		ad16 <= incounter(16);
		ad17 <= incounter(17);
	
		outmask <=mask;
		outset <= o_set;
	end process;

		
	
end rtl;