-------------------------------------------------------
-- 8bit latchi
-- 2021/10/13
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity latch8bit is
	port(
		latch	:in std_logic;
		d0		:in std_logic;
		d1		:in std_logic;
		d2		:in std_logic;
		d3		:in std_logic;
		d4		:in std_logic;
		d5		:in std_logic;
		d6		:in std_logic;
		d7		:in std_logic;		
		q0		:out std_logic;
		q1		:out std_logic;
		q2		:out std_logic;
		q3		:out std_logic;
		q4		:out std_logic;
		q5		:out std_logic;
		q6		:out std_logic;
		q7		:out std_logic		
	);
end latch8bit;

architecture rtl of latch8bit is
	signal input_data	:std_logic_vector(7 downto 0);

begin
	process(latch)
	begin
		if(latch' event and latch='1' ) then
			input_data <= d7 & d6 & d5 & d4 & d3 & d2 & d1 & d0;
		end if;
	end process;
	q0 <= input_data(0);
	q1 <= input_data(1);
	q2 <= input_data(2);
	q3 <= input_data(3);
	q4 <= input_data(4);
	q5 <= input_data(5);
	q6 <= input_data(6);
	q7 <= input_data(7);	

end rtl;