-------------------------------------------------------
-- 4bit x 2 to 1 select
-- 2021/10/12
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity sel2to1 is
	port(
		a0		:in std_logic;
		a1		:in std_logic;
		a2		:in std_logic;
		a3		:in std_logic;
		b0		:in std_logic;
		b1		:in std_logic;
		b2		:in std_logic;
		b3		:in std_logic;
		sel	:in std_logic;
		out0	:out std_logic;
		out1	:out std_logic;
		out2	:out std_logic;
		out3	:out std_logic
		);
end sel2to1;

architecture rtl of sel2to1 is
	signal input_t0		:std_logic_vector(3 downto 0);
	signal input_t1		:std_logic_vector(3 downto 0);
	signal input_sel		:std_logic;
	signal output_table	:std_logic_vector(3 downto 0);
	
begin
	input_t0 <= a3 & a2 & a1 & a0;
	input_t1 <= b3 & b2 & b1 & b0;
	input_sel <= sel;
	
	output_table <= input_t0 when input_sel='0' else input_t1;
	
	out0 <= output_table(0);
	out1 <= output_table(1);
	out2 <= output_table(2);
	out3 <= output_table(3);

end rtl;	
		